indexing
	description: "Vermittler (Mediator): implementiert Schnittstelle"
				 "fuer Interaktion mit den Kollegen-Objekten"
				 "kennt und verwaltet Kollegen-Objekte"

class VERMITTLER

creation
	make

feature {NONE}

	-- speichert die angemeldeten Kollegen
	kollegen: LINKED_SET[ KOLLEGE ];

feature

	-- constructor: erzeugt Kollegen
	make is
	do
		!!kollegen.make
	end;

	-- meldet Kollegen beim Vermittler an
	anmeldeKollege (k: KOLLEGE) is
	require k /= Void
	do
		kollegen.put (k);
	end;
		
	-- meldet Kollegen beim Vermittler ab
	abmeldeKollege (k: KOLLEGE) is
	require k /= Void
	do
		kollegen.prune (k)
	end;

	-- benachrichtigt alle Kollegen ueber deren
	-- zeichneMeldung()-Methode.
	informiereAlle (s: STRING) is
	do
		from kollegen.start
		until
			kollegen.exhausted
		loop
			kollegen.item.emfangeNachricht (s)
			kollegen.forth
		end;
	end;
		
end
